<template>
  <div class="box">
    <div class="el-card_top">
      <el-form :inline="true" :model="formInline" class="demo-form-inline">
        <!-- <el-form-item label="公司">

           <company-info-selector
            v-model='formInline.companyName'
            :valueName='formInline.companyIds'
            @handleChanged='handleChanged'
            @value='companyValue'
          />
        </el-form-item> -->
        <!-- <el-form-item label="路段">
          <router-info-selector
            v-model="formInline.roadSegmentId"
            :value="formInline.roadSegmentId"
            @changed="changed"
            @value="value"
          />
        </el-form-item> -->
        <el-form-item label="所在路段" prop="roadSegmentId">
          <el-select
            v-model="formInline.roadSegmentId"
            placeholder="请选择路段名称"
            style="width: 100%"
            @change="handleRoadChanged"
            clearable
          >
            <el-option
              v-for="item in roadOptions"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            ></el-option>
          </el-select>
        </el-form-item>
        <!-- <el-form-item>
          <el-button type="primary" @click="onSubmit" icon="el-icon-search"
            >查询</el-button
          >
        </el-form-item> -->
        <el-form-item>
          <!-- <el-button @click="onSubmit">重置</el-button> -->
        </el-form-item>
      </el-form>
      <!-- <road-info-dialog
        ref="road"
        :single="true"
        @select="handleSelectRoad"
      ></road-info-dialog> -->
    </div>
    <el-card class="box-card">
      <div id="main" style="width: 1200px; height: 500px; margin: 0 auto"></div>
    </el-card>
  </div>
</template>

<script>
import * as echarts from 'echarts'
import basicData from '@/api/basicData.js'
import eipOrgSelector from '@/components/eipControl/selector/EipOrgSelector.vue'
import RoadInfoDialog from '@/components/dialog/RoadInfoDialog.vue'
import routerInfoSelector from '@/components/selector/routerInfoSelector.vue'
export default {
  components: {
    // eipOrgSelector,
    // RoadInfoDialog,
    // routerInfoSelector,
  },
  data() {
    return {
      formInline: {
        companyName: '',
        roadSegmentName: ''
      },
      roadOptions: [] //选取路段
    }
  },
  mounted() {
    // this.draw()
    // this.load()
    this.getRoadInfo()
  },
  methods: {
    getRoadInfo() {
      basicData.getRoadManagement().then(res => {
        if (res.rows.length !== 0) {
          this.roadOptions = res.rows
          let id = this.roadOptions[0].id
          this.formInline = {
            roadSegmentId: id
          }
          this.load(id)
        }
      })
    },
    handleRoadChanged(id) {
      if (id) {
        this.load(id)
      }
    },
    draw(data) {
      var chartDom = document.getElementById('main')
      var myChart = echarts.init(chartDom)
      var option
      let arr1 = []
      let seri = []
      let names = [
        {key: 'mqiAvg', name: 'MQI'},
        {key: 'pqiAvg', name: '路面PQI'},
        {key: 'pciAvg', name: '路面损坏PCI'},
        {key: 'rqiAvg', name: '行驶质量RQI'},
        {key: 'rdiAvg', name: '车辙深度RDI'},
        {key: 'pbiAvg', name: '跳车PBI'},
        {key: 'sriAvg', name: '抗滑性能SRI'},
        {key: 'sciAvg', name: '路基SCI'},
        {key: 'bciAvg', name: '桥隧构造物BCI'},
        {key: 'tciAvg', name: '沿线设施TCI'},
        {key: 'pwiAvg', name: '磨耗PWI'},
        {key: 'pssiAvg', name: '结构强度PSSI'}
      ]
      console.log(data)
      let items = this.transformation(data[0], names)
      for (let i in items) {
        // console.log(items[i])
        arr1.push(items[i].name)
      }
      arr1 = arr1.filter(item => {
        return item
      })
      console.log(arr1)
      data.forEach(item => {
        seri.push({
          name: item.laneValue,
          type: 'line',
          stack: 'Total',
          data: item
        })
      })
      // seri = data
      seri.forEach(item => {
        delete item.data.laneValue
        delete item.data.lane
        let arr2 = []
        for (let i in item.data) {
          arr2.push(item.data[i])
          // item.data.push(item.data[i])
        }
        item.data = arr2
      })
      console.log(seri)
      option = {
        tooltip: {
          trigger: 'axis'
        },
        grid: {
          left: '3%',
          right: '4%',
          bottom: '3%',
          containLabel: true
        },
        toolbox: {
          feature: {
            saveAsImage: {}
          }
        },
        xAxis: {
          type: 'category',
          boundaryGap: false,
          data: arr1,
          axisLabel: {
            show: true,
            interval: 0,
            formatter: function(value) {
              var ret = '' //拼接加\n返回的类目项
              var maxLength = 4 //每项显示文字个数
              var valLength = value.length //X轴类目项的文字个数
              var rowN = Math.ceil(valLength / maxLength) //类目项需要换行的行数
              if (rowN > 4) {
                //如果类目项的文字大于4,
                for (var i = 0; i < rowN; i++) {
                  var temp = '' //每次截取的字符串
                  var start = i * maxLength //开始截取的位置
                  var end = start + maxLength //结束截取的位置
                  //这里也可以加一个是否是最后一行的判断，但是不加也没有影响，那就不加吧
                  temp = value.substring(start, end) + '\n'
                  ret += temp //凭借最终的字符串
                }
                return ret
              } else {
                return value
              }
            },
            textStyle: {
              color: '#9bd8ed', //X轴文字颜色
              padding: [0, 0, 0, 0],
              fontSize: 12
            }
          }
        },
        yAxis: {
          type: 'value'
        },
        series: seri
      }

      option && myChart.setOption(option)
    },
    load(roadSegmentId) {
      this.$http
        .post('${yhxt}/statisticalStatement/v1/countMqiReport', {
          roadSegmentId
        })
        .then(res => {
          console.log(res)
          this.draw(res.data.value)
        })
    },
    transformation(data, arr) {
      let arr1 = []
      for (let i in data) {
        // console.log(i, data[i])
        let o = {}
        o['name'] = i
        o['value'] = data[i]
        for (let j in arr) {
          // console.log(arr1[j], j, o)
          if (arr[j].key == o.name) {
            o.name = arr[j].name
            arr1.push(o)
          }
        }
      }
      return arr1
    },
    onSubmit() {
      console.log('submit!')
    },
    //所属路段获取焦点触发事件
    handleFocusRoad() {
      this.$refs.road.open()
    },
    //所属路线打开弹框
    openRoad() {
      this.$refs.road.open()
    },
    //选取路线回填数据
    handleSelectRoad(data) {
      // console.log(data.name, '路线信息')
      // this.formInline.roadSegmentName = data.name
      // this.formInline.roadSegmentId = data.id
    },
    //路线信息赋值
    changed(obj) {
      // console.log(obj)
      this.formInline.roadSegmentName = obj.name
      this.formInline.roadSegmentId = obj.id
    },
    value(obj) {
      console.log(obj)
      this.formInline.roadSegmentName = obj.name
      this.formInline.roadSegmentId = obj.id
    },
    //公司赋值
    handleChanged(obj) {
      // console.log(obj.valueInfo.join(','))
      this.formInline.companyIds = JSON.stringify(obj.valueInfo)
      this.formInline.companyName = obj.name
      this.formInline.companyId = obj.id
    },
    companyValue(obj) {
      // console.log(obj)
      this.formInline.companyName = obj.name
      this.formInline.companyId = obj.id
      this.formInline.companyIds = JSON.stringify(obj.id.split(' ')) //必须是空格
    }
  }
}
</script>

<style lang="scss" scoped>
.el-form {
  margin-top: 8px;
  margin-left: 10px;
}
.el-card {
  margin: 10px;
}
.box-card {
  margin: 0 10px;
}
.item {
  display: flex;
  justify-content: space-between;
}
.el-card_top {
  height: 50px;
  margin: 10px;
  border-radius: 4px;
  border: 1px solid #113556;
  background-color: #103c5d !important;
  overflow: hidden;
  color: #303133;
  transition: 0.3s;
  box-shadow: 0 2px 12px #eee;
}
.box {
  overflow: auto;
}
/deep/ .el-select__tags[data-v-2f5be1c8] {
  margin-top: 1px;
}
/* 设置滚动条的样式 */
/deep/ ::-webkit-scrollbar {
  width: 8px;
  background-color: #fff;
}

/* 滚动槽 */
/deep/ ::-webkit-scrollbar-track {
  border-radius: 8px;
}

/* 滚动条滑块 */
/deep/ ::-webkit-scrollbar-thumb {
  border-radius: 8px;
  background: #eee;
}
</style>
